## knot-resolver 2.1.1

=== Makefile ===
include config.mk
include platform.mk

# Targets
all: info lib daemon client modules etc
install: lib-install daemon-install client-install modules-install etc-install
check: all tests
clean: contrib-clean lib-clean daemon-clean client-clean modules-clean \
	tests-clean doc-clean bench-clean coverage-clean
doc: doc-html
lint: lint-lua lint-c
lint-c: libkres-lint kresd-lint kresc-lint
lint-lua: $(patsubst %.lua.in,%.lua,$(wildcard */*/*.lua.in))
	luacheck --codes --formatter TAP .

.PHONY: all install check clean doc info lint

# Dependencies
KNOT_MINVER := 2.6.4
$(eval $(call find_lib,libknot,$(KNOT_MINVER),yes))
$(eval $(call find_lib,libdnssec,$(KNOT_MINVER),yes))
$(eval $(call find_lib,libzscanner,$(KNOT_MINVER),yes))
$(eval $(call find_lib,lmdb))
$(eval $(call find_lib,libuv,1.0,yes))
$(eval $(call find_lib,nettle,,yes))
$(eval $(call find_alt,lua,luajit))
$(eval $(call find_luapkg,ltn12))
$(eval $(call find_luapkg,ssl.https))
$(eval $(call find_lib,cmocka))
$(eval $(call find_bin,doxygen))
$(eval $(call find_bin,sphinx-build))
$(eval $(call find_pythonpkg,breathe))
#$(eval $(call find_lib,libmemcached,1.0))
#$(eval $(call find_lib,hiredis,,yes))
$(eval $(call find_lib,socket_wrapper))
$(eval $(call find_lib,libsystemd,227))
$(eval $(call find_lib,gnutls))
$(eval $(call find_lib,libedit))
$(eval $(call find_lib,libprotobuf-c,1))
$(eval $(call find_lib,libfstrm,0.2))
$(eval $(call find_bin,protoc-c))
$(eval $(call find_bin,lcov))
$(eval $(call find_bin,luacov))

# Lookup SONAME
$(eval $(call find_soname,libknot))
$(eval $(call find_soname,libzscanner))

ifeq ($(libknot_SONAME),)
  $(error "Unable to resolve libknot_SONAME, update find_soname in platform.mk")
endif
ifeq ($(libzscanner_SONAME),)
  $(error "Unable to resolve libzscanner_SONAME, update find_some in platform.mk")
endif

# Find Go version and platform
GO_VERSION := $(shell $(GO) version 2>/dev/null)
ifeq ($(GO_VERSION),)
        GO_VERSION := 0
else
        GO_PLATFORM := $(word 2,$(subst /, ,$(word 4,$(GO_VERSION))))
        GO_VERSION := $(subst .,,$(subst go,,$(word 3,$(GO_VERSION))))
endif
$(eval $(call find_ver,go,$(GO_VERSION),16))

# Check if Go is able to build shared libraries
ifeq ($(HAS_go),yes)
ifneq ($(GO_PLATFORM),$(filter $(GO_PLATFORM),amd64 386 arm arm64))
HAS_go := no
endif
else
$(eval $(call find_ver,go,$(GO_VERSION),15))
ifeq ($HAS_go,yes)
ifneq ($(GO_PLATFORM),$(filter $(GO_PLATFORM),arm amd64))
HAS_go := no
endif
endif
endif

# check for fstrm and protobuf for dnstap
ifeq ($(HAS_libfstrm)|$(HAS_libprotobuf-c)|$(HAS_protoc-c),yes|yes|yes)
ENABLE_DNSTAP := yes
endif

# Overview
info:
	$(info Target:     Knot DNS Resolver $(VERSION)-$(PLATFORM))
	$(info Compiler:   $(CC) $(BUILD_CFLAGS))
	$(info Linker:     $(CCLD) $(BUILD_LDFLAGS))
	$(info )
	$(info Variables)
	$(info ---------)
	$(info HARDENING:  $(HARDENING))
	$(info BUILDMODE:  $(BUILDMODE))
	$(info PREFIX:     $(PREFIX))
	$(info PREFIX:     $(PREFIX))
	$(info DESTDIR:    $(DESTDIR))
	$(info BINDIR:     $(BINDIR))
	$(info SBINDIR:    $(SBINDIR))
	$(info LIBDIR:     $(LIBDIR))
	$(info ETCDIR:     $(ETCDIR))
	$(info INCLUDEDIR: $(INCLUDEDIR))
	$(info MODULEDIR:  $(MODULEDIR))
	$(info )
	$(info Core Dependencies)
	$(info ------------)
	$(info [$(HAS_libknot)] libknot (lib))
	$(info [yes] $(if $(filter $(HAS_lmdb),yes),system,embedded) lmdb (lib))
	$(info [$(HAS_lua)] luajit (daemon))
	$(info [$(HAS_libuv)] libuv (daemon))
	$(info [$(HAS_gnutls)] libgnutls (daemon))
	$(info )
	$(info Optional)
	$(info --------)
	$(info [$(HAS_doxygen)] doxygen (doc))
	$(info [$(HAS_sphinx-build)] sphinx-build (doc))
	$(info [$(HAS_breathe)] python-breathe (doc))
	$(info [$(HAS_go)] go (modules/go, Go buildmode=c-shared support))
#	$(info [$(HAS_libmemcached)] libmemcached (modules/memcached))
#	$(info [$(HAS_hiredis)] hiredis (modules/redis))
	$(info [$(HAS_cmocka)] cmocka (tests/unit))
	$(info [$(HAS_libsystemd)] systemd (daemon))
	$(info [$(HAS_nettle)] nettle (modules/cookies))
	$(info [$(HAS_ltn12)] Lua socket ltn12 (trust anchor bootstrapping))
	$(info [$(HAS_ssl.https)] Lua ssl.https (trust anchor bootstrapping))
	$(info [$(HAS_libedit)] libedit (client))
	$(info [$(HAS_libfstrm)] libfstrm (modules/dnstap))
	$(info [$(HAS_libprotobuf-c)] libprotobuf-c (modules/dnstap))
	$(info [$(HAS_protoc-c)] proto-c (modules/dnstap))
	$(info [$(HAS_lcov)] lcov (code coverage))
	$(info [$(HAS_luacov)] luacov (code coverage))
	$(info )

# Verify required dependencies are met, as listed above
ifeq ($(HAS_libknot),no)
	$(error libknot >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_libzscanner),no)
	$(error libzscanner >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_libdnssec),no)
	$(error libdnssec >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_lua),no)
	$(error luajit required)
endif
ifeq ($(HAS_libuv),no)
	$(error libuv >= 1.0 required)
endif
ifeq ($(HAS_gnutls),no)
	$(error gnutls required)
endif


BUILD_CFLAGS += $(libknot_CFLAGS) $(libuv_CFLAGS) $(nettle_CFLAGS) $(cmocka_CFLAGS) $(lua_CFLAGS) $(libdnssec_CFLAGS) $(libsystemd_CFLAGS)
BUILD_CFLAGS += $(addprefix -I,$(wildcard contrib/ccan/*) contrib/murmurhash3)

# Work around luajit on OS X
ifeq ($(PLATFORM), Darwin)
ifneq (,$(findstring luajit, $(lua_LIBS)))
	lua_LIBS += -pagezero_size 10000 -image_base 100000000
endif
endif

# Check if it has nettle to support DNS cookies
ifeq ($(HAS_nettle), yes)
BUILD_CFLAGS += -DENABLE_COOKIES
ENABLE_COOKIES := yes
endif

# Installation directories
$(DESTDIR)$(MODULEDIR):
	$(INSTALL) -d $@
$(DESTDIR)$(ETCDIR):
	$(INSTALL) -m 0755 -d $@

# Sub-targets
include contrib/contrib.mk
include coverage.mk
include lib/lib.mk
include client/client.mk
include daemon/daemon.mk
include modules/modules.mk
include tests/tests.mk
include doc/doc.mk
include etc/etc.mk
include bench/bench.mk

=== doc/requirements.txt ===
Sphinx
breathe

=== tests/deckard/Makefile ===
# Defaults
TESTS ?= sets/resolver
DAEMON ?= kresd
TEMPLATE ?= template/kresd.j2
CONFIG ?= config
ADDITIONAL ?= -f 1
OPTS ?=

PYTHON ?= python3
LIBEXT := .so
PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
	LIBEXT := .dylib
endif

# Find all sub-targets
TARGETS := $(TESTS)
ifeq (,$(findstring .rpl,$(TESTS)))
TARGETS := $(wildcard $(TESTS)/*.rpl)
endif
SOURCES := $(TARGETS)
TARGETS := $(sort $(patsubst %.rpl,%.out-qmin,$(SOURCES))) $(sort $(patsubst %.rpl,%.out-noqmin,$(SOURCES)))

# Dependencies
include platform.mk
libcwrap_DIR := contrib/libswrap
libcwrap_cmake_DIR := $(libcwrap_DIR)/obj
libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper$(LIBEXT).0
ifeq ($(PLATFORM),Darwin)
	libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper.0$(LIBEXT)
endif
libfaketime_DIR := contrib/libfaketime
libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime$(LIBEXT).1

# Platform-specific targets
ifeq ($(PLATFORM),Darwin)
	libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime.1$(LIBEXT)
	preload_syms := DYLD_LIBRARY_PATH=$(DYLD_LIBRARY_PATH) DYLD_FORCE_FLAT_NAMESPACE=1 DYLD_INSERT_LIBRARIES="$(libfaketime):$(libcwrap)"
else
	preload_syms := LD_PRELOAD="$(libfaketime):$(libcwrap)"
endif

# Test coverage measurement
# User has to provide own coverage_env.sh to generate environment variables for daemon under test
ifdef COVERAGE
ifndef COVERAGE_ENV_SCRIPT
$(error COVERAGE requires COVERAGE_ENV_SCRIPT with path to scripts/coverage_env.sh for given daemon)
endif
ifndef DAEMONSRCDIR
$(error COVERAGE requires DAEMONSRCDIR pointing to source directory of daemon under test)
endif
ifndef COVERAGE_STATSDIR
$(error COVERAGE requires COVERAGE_STATSDIR pointing to output directory)
endif
define set_coverage_env
$(shell "$(COVERAGE_ENV_SCRIPT)" "$(DAEMONSRCDIR)" "$(COVERAGE_STATSDIR)" "$(1)")
endef
endif


# Targets
all: $(TARGETS)
depend: $(libfaketime) $(libcwrap)

# Generic rule to run test
$(SOURCES): depend
%.out-qmin: %.rpl
	@test "$${QMIN:-true}" = "true" || exit 0 && \
	$(call set_coverage_env,$@) $(preload_syms) $(PYTHON) $(abspath ./deckard.py) --qmin true $(OPTS) $< one $(DAEMON) $(TEMPLATE) $(CONFIG) -- $(ADDITIONAL)

%.out-noqmin: %.rpl
	@test "$${QMIN:-false}" = "false" || exit 0 && \
	$(call set_coverage_env,$@) $(preload_syms) $(PYTHON) $(abspath ./deckard.py) --qmin false $(OPTS) $< one $(DAEMON) $(TEMPLATE) $(CONFIG) -- $(ADDITIONAL)

# Synchronize submodules
submodules: .gitmodules
	@git submodule update --init
# indirection through submodules target is necessary
# to prevent make from running "git submodule" commands in parallel
$(libfaketime_DIR)/Makefile $(libcwrap_DIR)/CMakeLists.txt: submodules
$(libfaketime): $(libfaketime_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libfaketime_DIR)
$(libcwrap_cmake_DIR):$(libcwrap_DIR)/CMakeLists.txt
	@mkdir -p $(libcwrap_cmake_DIR)
$(libcwrap_cmake_DIR)/Makefile: $(libcwrap_cmake_DIR)
	@cd $(libcwrap_cmake_DIR); cmake ..
$(libcwrap): $(libcwrap_cmake_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libcwrap_cmake_DIR)


.PHONY: submodules depend all

check:
	@echo Running unittests using pytest
	${PYTHON} -m pytest

=== tests/deckard/requirements.txt ===
dnspython>=1.15
Jinja2>=2.8
PyYAML
python-augeas
pytest

=== modules/policy/lua-aho-corasick/Makefile ===
OS := $(shell uname)

ifeq ($(OS), Darwin)
    SO_EXT := dylib
else
    SO_EXT := so
endif

#############################################################################
#
#           Binaries we are going to build
#
#############################################################################
#
C_SO_NAME = libac.$(SO_EXT)
LUA_SO_NAME = ahocorasick.$(SO_EXT)
AR_NAME = libac.a

#############################################################################
#
#           Compile and link flags
#
#############################################################################
PREFIX = /usr/local
LUA_VERSION := 5.1
PREFIX = /usr/local
LUA_INCLUDE_DIR := $(PREFIX)/include/lua$(LUA_VERSION)
SO_TARGET_DIR := $(PREFIX)/lib/lua/$(LUA_VERSION)
LUA_TARGET_DIR := $(PREFIX)/share/lua/$(LUA_VERSION)

# Available directives:
# -DDEBUG : Turn on debugging support
# -DVERIFY : To verify if the slow-version and fast-version implementations
#            get exactly the same result. Note -DVERIFY implies -DDEBUG.
#
CFLAGS = -msse2 -msse3 -msse4.1 -O3 #-g -DVERIFY
COMMON_FLAGS = -fvisibility=hidden -Wall $(CFLAGS) $(MY_CFLAGS) $(MY_CXXFLAGS)

SO_CXXFLAGS = $(COMMON_FLAGS) -fPIC
SO_LFLAGS = $(COMMON_FLAGS)
AR_CXXFLAGS = $(COMMON_FLAGS)

# -DVERIFY implies -DDEBUG
ifneq ($(findstring -DVERIFY, $(COMMON_FLAGS)), )
ifeq ($(findstring -DDEBUG, $(COMMON_FLAGS)), )
    COMMON_FLAGS += -DDEBUG
endif
endif

AR = ar
AR_FLAGS = cru

#############################################################################
#
#       Divide source codes and objects into several categories
#
#############################################################################
#
SRC_COMMON := ac_fast.cxx ac_slow.cxx
LIBAC_SO_SRC := $(SRC_COMMON) ac.cxx    # source for libac.so
LUA_SO_SRC := $(SRC_COMMON) ac_lua.cxx  # source for ahocorasick.so
LIBAC_A_SRC := $(LIBAC_SO_SRC)          # source for libac.a

#############################################################################
#
#                   Make rules
#
#############################################################################
#
.PHONY = all clean test benchmark prepare
all : $(C_SO_NAME) $(LUA_SO_NAME) $(AR_NAME)

-include c_so_dep.txt
-include lua_so_dep.txt
-include ar_dep.txt

BUILD_SO_DIR := build_so
BUILD_AR_DIR := build_ar

$(BUILD_SO_DIR) :; mkdir $@
$(BUILD_AR_DIR) :; mkdir $@

$(BUILD_SO_DIR)/%.o : %.cxx | $(BUILD_SO_DIR)
	$(CXX) $< -c $(SO_CXXFLAGS) -I$(LUA_INCLUDE_DIR) -MMD -o $@

$(BUILD_AR_DIR)/%.o : %.cxx | $(BUILD_AR_DIR)
	$(CXX) $< -c $(AR_CXXFLAGS) -I$(LUA_INCLUDE_DIR) -MMD -o $@

ifneq ($(OS), Darwin)
$(C_SO_NAME) : $(addprefix $(BUILD_SO_DIR)/, ${LIBAC_SO_SRC:.cxx=.o})
	$(CXX) $+ -shared -Wl,-soname=$(C_SO_NAME) $(SO_LFLAGS) -o $@
	cat $(addprefix $(BUILD_SO_DIR)/, ${LIBAC_SO_SRC:.cxx=.d}) > c_so_dep.txt

$(LUA_SO_NAME) : $(addprefix $(BUILD_SO_DIR)/, ${LUA_SO_SRC:.cxx=.o})
	$(CXX) $+ -shared -Wl,-soname=$(LUA_SO_NAME) $(SO_LFLAGS) -o $@
	cat $(addprefix $(BUILD_SO_DIR)/, ${LUA_SO_SRC:.cxx=.d}) > lua_so_dep.txt

else
$(C_SO_NAME) : $(addprefix $(BUILD_SO_DIR)/, ${LIBAC_SO_SRC:.cxx=.o})
	$(CXX) $+ -shared $(SO_LFLAGS) -o $@
	cat $(addprefix $(BUILD_SO_DIR)/, ${LIBAC_SO_SRC:.cxx=.d}) > c_so_dep.txt

$(LUA_SO_NAME) : $(addprefix $(BUILD_SO_DIR)/, ${LUA_SO_SRC:.cxx=.o})
	$(CXX) $+ -shared $(SO_LFLAGS) -o $@ -Wl,-undefined,dynamic_lookup
	cat $(addprefix $(BUILD_SO_DIR)/, ${LUA_SO_SRC:.cxx=.d}) > lua_so_dep.txt
endif

$(AR_NAME) : $(addprefix $(BUILD_AR_DIR)/, ${LIBAC_A_SRC:.cxx=.o})
	$(AR) $(AR_FLAGS) $@ $+
	cat $(addprefix $(BUILD_AR_DIR)/, ${LIBAC_A_SRC:.cxx=.d}) > lua_so_dep.txt

#############################################################################
#
#           Misc
#
#############################################################################
#
test : $(C_SO_NAME)
	$(MAKE) -C tests && \
	luajit tests/lua_test.lua && \
	luajit tests/load_ac_test.lua

benchmark: $(C_SO_NAME)
	$(MAKE) benchmark -C tests

clean :
	-rm -rf *.o *.d c_so_dep.txt lua_so_dep.txt ar_dep.txt $(TEST) \
        $(C_SO_NAME) $(LUA_SO_NAME) $(TEST) $(BUILD_SO_DIR) $(BUILD_AR_DIR) \
        $(AR_NAME)
	make clean -C tests

install:
	install -D -m 755 $(C_SO_NAME) $(DESTDIR)/$(SO_TARGET_DIR)/$(C_SO_NAME)
	install -D -m 755 $(LUA_SO_NAME) $(DESTDIR)/$(SO_TARGET_DIR)/$(LUA_SO_NAME)
	install -D -m 664 load_ac.lua $(DESTDIR)/$(LUA_TARGET_DIR)/load_ac.lua

=== tests/deckard/contrib/libfaketime/man/Makefile ===
INSTALL ?= install

PREFIX ?= /usr/local

all:

install:
	$(INSTALL) -Dm0644 faketime.1 "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"
	gzip -f "${DESTDIR}${PREFIX}/share/man/man1/faketime.1"

uninstall:
	rm -f "${DESTDIR}${PREFIX}/share/man/man1/faketime.1.gz"

.PHONY: all install uninstall

=== tests/deckard/contrib/libfaketime/src/Makefile ===
#
# Notes:
#
#   * Compilation Defines:
#
#     FAKE_STAT
#         - Enables time faking also for files' timestamps.
#
#     NO_ATFILE
#         - Disables support for the fstatat() group of functions
#
#     PTHREAD
#         - Define this to enable multithreading support.
#
#     PTHREAD_SINGLETHREADED_TIME
#         - Define this if you want to single-thread time() ... there ARE
#           possibile caching side-effects in a multithreaded environment
#           without this, but the performance impact may require you to
#           try it unsynchronized.
#
#     FAKE_INTERNAL_CALLS
#         - Also intercept libc internal __functions, e.g. not just time(),
#           but also __time(). Enhances compatibility with applications
#           that make use of low-level system calls, such as Java Virtual
#           Machines.
#
# 	  FAKE_SLEEP
# 	      - Also intercept sleep(), nanosleep(), usleep(), alarm(), [p]poll()
#
#	  FAKE_TIMERS
#	      - Also intercept timer_settime() and timer_gettime()
#
#	  MULTI_ARCH
#	  	  - If MULTI_ARCH is set, the faketime wrapper program will put a literal
#	  	    $LIB into the LD_PRELOAD environment variable it creates, which makes
#	  	    ld automatically choose the correct library version to use for the
#	  	    target binary. Use for Linux platforms with Multi-Arch support only!
#
#   * Compilation addition: second libMT target added for building the pthread-
#     enabled library as a separate library
#
#   * Compilation switch change: previous versions compiled using '-nostartfiles'
#     This is no longer the case since there is a 'startup' constructor for the library
#     which is used to activate the start-at times when specified. This also initializes
#     the dynamic disabling of the FAKE_STAT calls.
#
# By default, libfaketime will be compiled for your system's default architecture.
# To build 32-bit libraries and binaries, add -m32 to CFLAGS and LDFLAGS.
#
# Change PREFIX to where you want libfaketime (libraries and wrapper binary) installed.
# LIBDIRNAME is relative to PREFIX. The default is to install into $PREFIX/lib/faketime,
# but you can set LIBDIRNAME to, e.g., /lib64 if you want to install it elsewhere.
# LIBDIRNAME has been introduced to support MultiLib systems. Please do not change the 
# default value on MultiArch systems. 
#
# For testing in the current directory without installation, try make PREFIX= LIBDIRNAME='.'

CC ?= gcc
INSTALL ?= install

PREFIX ?= /usr/local
LIBDIRNAME ?= /lib/faketime
PLATFORM ?=$(shell uname)

CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"'
ifeq ($(PLATFORM),SunOS)
CFLAGS += -D__EXTENSIONS__ -D_XOPEN_SOURCE=600
endif

LIB_LDFLAGS += -shared

LDFLAGS += -lpthread
ifneq ($(PLATFORM),SunOS)
LDFLAGS += -Wl,--version-script=libfaketime.map
endif

LDADD += -ldl -lm -lrt
BIN_LDFLAGS += -lrt

SRC = libfaketime.c
LIBS_OBJ = libfaketime.o libfaketimeMT.o
BINS = faketime

SONAME = 1
LIBS = libfaketime.so.${SONAME} libfaketimeMT.so.${SONAME}

all: ${LIBS} ${BINS}

libfaketimeMT.o: EXTRA_FLAGS := -DPTHREAD -DPTHREAD_SINGLETHREADED_TIME

${LIBS_OBJ}: libfaketime.c
	${CC} -o $@ -c ${CFLAGS} ${EXTRA_FLAGS} $<

%.so.${SONAME}: %.o libfaketime.map
	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} ${LIB_LDFLAGS} $< ${LDADD}

${BINS}: faketime.c
	${CC} -o $@ ${CFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${BIN_LDFLAGS}

clean:
	@rm -f ${LIBS_OBJ} ${LIBS} ${BINS}

distclean: clean
	@echo

install: ${LIBS} ${BINS}
	@echo
	@echo "Copying the faketime libraries to ${DESTDIR}${PREFIX}${LIBDIRNAME} and the faketime wrapper script to ${DESTDIR}${PREFIX}/bin ..."
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -m0644 ${LIBS} "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -Dm0755 faketime "${DESTDIR}${PREFIX}/bin/faketime"

uninstall:
	for f in ${LIBS}; do rm -f "${DESTDIR}${PREFIX}${LIBDIRNAME}/$$f"; done
	rmdir "${DESTDIR}${PREFIX}${LIBDIRNAME}"
	rm -f "${DESTDIR}${PREFIX}/bin/faketime"

.PHONY: all clean distclean install uninstall

=== debian/changelog ===
knot-resolver (2.1.1-1) unstable; urgency=medium

  * new upstream release
  * drop patches already upstream
  * refresh remaining patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 25 Feb 2018 17:36:46 -0800

knot-resolver (2.1.0-2) unstable; urgency=medium

  * clean up README.source
  * more bugfix patches from upstream

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 22 Feb 2018 13:27:59 -0800

knot-resolver (2.1.0-1) unstable; urgency=medium

  * new upstream release
    - move from libkres5 to libkres6 due to an ABI change
    - kresd.systemd(7) documents running a public-facing resolver
      (Closes: #880682)
  * d/upstream/signing-key.asc: add Tomas Krizek's key
  * d/gbp.conf: use DEP-14 branch naming
  * drop patches already upstream
  * d/control: build-depend on libknot-dev (>= 2.6.4)
  * handle updates to the DNS root.key sensibly (dpkg triggers)
  * systemd: mask kresd.service, following upstream's recommendation
  * /etc/default/kresd: indicate that it is only for sysvinit
  * d/rules: clean up unnecessary lines
  * systemd: ship upstream unit files and tmpfiles config directly
  * d/control: Rules-Requires-Root: no
  * use python3 during the build.
  * ship upstream NEWS file as upstream changelog
  * debian/TODO: clean up

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 17 Feb 2018 21:13:45 -0500

knot-resolver (2.0.0-3) unstable; urgency=medium

  * documentation: build with sphinx_rtd_theme

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 05 Feb 2018 17:13:04 -0500

knot-resolver (2.0.0-2) unstable; urgency=medium

  * Simplify /etc/default/kresd
  * drop preinst special case for versions < 1.1.0-2
  * postinst: create the knot-resolver user at configure time
  * initscript knows path to /usr/lib/tmpfiles.d/knot-resolver.conf
  * Overhaul systemd integration.
  * d/copyright: include more contributed subprojects (Closes: #889646)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 05 Feb 2018 13:46:25 -0500

knot-resolver (2.0.0-1) unstable; urgency=medium

  [ Ondřej Surý ]
  * Reduce the (non-public) symbols in libkres4

  [ Daniel Kahn Gillmor ]
  * import systemd fixes from Tomas Krizek
  * avoid leaving /run/knot-resolver world-executable
  * systemd: set up kresd@1 service and sockets
  * wrap-and-sort -ast
  * Add kresd.service as a symlink to kresd@1.service
  * more bugfixes from upstream
  * NEWS: document changes for using kresd with systemd
  * include new lua modules
  * move from libkres4 to libkres5 (cache functions dropped)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 05 Feb 2018 00:25:51 -0500

knot-resolver (1.5.3-1) unstable; urgency=medium

  * New upstream release

 -- Ondřej Surý <ondrej@debian.org>  Wed, 24 Jan 2018 12:35:55 +0000

knot-resolver (1.5.2-1) unstable; urgency=medium

  * New upstream release
    - closes CVE-2018-1000002
  * d/copyright: use https where possible
  * move to debhelper 11 (docs to /u/s/doc/knot-resolver/, policy §12.3)
  * d/control: move Maintainer: to knot-resolver@packages.debian.org

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 22 Jan 2018 15:00:21 +0100

knot-resolver (1.5.1-2) unstable; urgency=medium

  * libkres-dev Depends on libkres4 (Closes: #887572)
  * Standards-Version: bump to 4.1.3 (no changes needed)
  * move Vcs-* to salsa.debian.org

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 17 Jan 2018 23:23:45 -0500

knot-resolver (1.5.1-1) unstable; urgency=medium

  * new upstream release
  * move packaging split to unstable
  * d/watch: move to version 4, avoid alpha/beta releases
  * drop patches for bugs already fixed upstream
  * use "make installcheck" as a simple test
  * track evolving name of etcd module
  * wrap-and-sort -a
  * shipping new modules: priming, detect_time_{jump,skew}
  * added kr_now to exported symbols
  * Standards-Version: bump to 4.1.2 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 13 Dec 2017 15:40:10 -0500

knot-resolver (1.5.0-5) experimental; urgency=medium

  * packaging cleanup, splitting out library packages
  * dbgsym migration no longer needed
    knot-resolver-dbg is not shipped anywhere
  * clean up installation of knot-resolver-module-http
  * move to dh_missing, as dh_install --fail-missing is deprecated
  * clean up/simplify knot-resolver.install
  * break out libkres library packages
  * put manpage installation under control of dh_installman
  * knock stuff off the packaging todo list
  * register knot-resolver-doc with doc-base
  * add libkres4.symbols to track API evolution
  * correct debian/copyright paths

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Nov 2017 23:25:54 -0500

knot-resolver (1.5.0-4) unstable; urgency=medium

  * Pull upstream patch to increase the CACHE_SIZE in tests_cache for
    platforms with page size greater than 4k (Closes: #878976)
  * Pull upstream patch from MR!389 to not run check-config at all as
    modulepath is hardcoded (Closes: #881492)

 -- Ondřej Surý <ondrej@debian.org>  Mon, 13 Nov 2017 19:53:30 +0000

knot-resolver (1.5.0-3) unstable; urgency=medium

  * reorder tests

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 13 Nov 2017 03:24:06 +0800

knot-resolver (1.5.0-2) unstable; urgency=medium

  * include a list of suggestions for future packaging work
  * try some debugging to see failures for #881492

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 13 Nov 2017 03:19:21 +0800

knot-resolver (1.5.0-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: update source homepage (Closes: #879166)
  * Standards-Version: bump to 4.1.1 (no changes needed)
  * switch to debhelper 10
  * drop dh-systemd build-dep -- no longer needed (may be added back for
    backports)
  * [lintian] fix debian-news-entry-uses-asterisk
  * drop unused lintian overrides
  * added myself to uploaders
  * update upstream signer key
  * patch from upstream for SIGPIPE (Closes: #881462)
  * patch to fix upstream test suite


=== debian/control ===
Source: knot-resolver
Section: net
Priority: optional
Maintainer: knot-resolver packagers <knot-resolver@packages.debian.org>
Uploaders:
 Ondřej Surý <ondrej@debian.org>,
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
Build-Depends-Indep:
 doxygen,
 python3-breathe,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Build-Depends:
 debhelper (>= 11~),
 dns-root-data,
 libcmocka-dev (>= 1.0.0),
 libedit-dev,
 libgeoip-dev,
 libgnutls28-dev,
 libhiredis-dev,
 libjansson-dev,
 libknot-dev (>= 2.6.4),
 liblmdb-dev,
 libluajit-5.1-dev,
 libmemcached-dev,
 libsystemd-dev (>= 227),
 libuv1-dev,
 luajit,
 pkg-config,
 python3,
Standards-Version: 4.1.3
Homepage: https://www.knot-resolver.cz/
Vcs-Browser: https://salsa.debian.org/dns-team/knot-resolver
Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git
Rules-Requires-Root: no

Package: knot-resolver
Architecture: any
Depends:
 adduser,
 dns-root-data,
 libkres6 (= ${binary:Version}),
 lua-sec,
 lua-socket,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 knot-resolver-module-http,
Description: caching, DNSSEC-validating DNS resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 The Lua modules, switchable and shareable cache, and fast FFI
 bindings makes it great to tap into resolution process, or be used
 for your recursive DNS service. It's the OpenResty of DNS.
 .
 The server adopts a different scaling strategy than the rest of the
 DNS recursors - no threading, shared-nothing architecture (except
 MVCC cache that may be shared). You can start and stop additional
 nodes depending on the contention without downtime.

Package: knot-resolver-module-http
Architecture: all
Depends:
 libjs-bootstrap,
 libjs-d3,
 libjs-jquery,
 lua-http,
 lua-mmdb,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 knot-resolver-module-tinyweb (<< 1.1.0~git20160713-1~),
Description: HTTP/2 module for Knot Resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains HTTP/2 module for local visualization of the
 resolver cache and queries.

Package: knot-resolver-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 libjs-underscore,
 ${misc:Depends},
Description: Documentation for Knot Resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains Knot Resolver Documentation.

Package: libkres6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 knot-resolver (<< 1.5.0-5),
Replaces:
 knot-resolver (<< 1.5.0-5),
Description: caching, DNSSEC-validating DNS resolver (shared library)
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions.
 .
 This package contains the libkres shared library used by Knot
 Resolver.

Package: libkres-dev
Architecture: any
Section: libdevel
Depends:
 libkres6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 knot-resolver (<< 1.5.0-5),
Replaces:
 knot-resolver (<< 1.5.0-5),
Description: caching, DNSSEC-validating DNS resolver (shared library development files)
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions.
 .
 This package provides development files for use when building against
 the libkres shared library.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -fno-omit-frame-pointer
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export ARCH=$(DEB_HOST_GNU_CPU)
export PREFIX=/usr
export MODULEDIR=/usr/lib/knot-resolver
export ETCDIR=/etc/knot-resolver

RUN_TESTS := yes
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),hurd-i386 mips mipsel ppc64 ppc64el armel armhf arm64 kfreebsd-amd64 kfreebsd-i386))
  $(warning Disabling checks on $(DEB_HOST_ARCH))
  RUN_TESTS := no
endif

%:
	dh $@

override_dh_auto_clean-indep:
	dh_auto_clean -- doc-clean http-clean

override_dh_auto_build-arch:
	CFLAGS="$${CFLAGS} -DNDEBUG" dh_auto_build -- V=1 BUILDMODE=static lib
	CFLAGS="$${CFLAGS} -DNDEBUG" dh_auto_build -- V=1 \
	 ROOTHINTS=/usr/share/dns/root.hints \
	 KEYFILE_DEFAULT=/usr/share/dns/root.key

override_dh_auto_build-indep:
	dh_auto_build -- V=1 http
	dh_auto_build -- V=1 doc-doxygen
	cd doc && sphinx-build -b html -D html_theme=nature . html

override_dh_auto_install-arch:
	dh_auto_install --destdir=debian/tmp -- V=1

override_dh_auto_install-indep:
# install just the http/2 module
	make http-install DESTDIR=debian/tmp V=1

override_dh_installinit:
	dh_installinit -pknot-resolver --name=kresd --no-start

override_dh_installsystemd:
	dh_installsystemd -pknot-resolver --name=kresd kresd-tls.socket kresd.socket

override_dh_auto_test-indep:
override_dh_auto_test-arch:
ifeq ($(RUN_TESTS),yes)
	dh_auto_test -- V=1
endif

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/tests/control ===
Test-Command: make installcheck
Depends: @, @builddeps@

## knot-resolver 2.3.0

=== modules/policy/lua-aho-corasick/Makefile ===
--- 
+++ 
@@ -21,9 +21,8 @@
 #           Compile and link flags
 #
 #############################################################################
-PREFIX = /usr/local
+PREFIX ?= /usr/local
 LUA_VERSION := 5.1
-PREFIX = /usr/local
 LUA_INCLUDE_DIR := $(PREFIX)/include/lua$(LUA_VERSION)
 SO_TARGET_DIR := $(PREFIX)/lib/lua/$(LUA_VERSION)
 LUA_TARGET_DIR := $(PREFIX)/share/lua/$(LUA_VERSION)
@@ -34,10 +33,10 @@
 #            get exactly the same result. Note -DVERIFY implies -DDEBUG.
 #
 CFLAGS = -msse2 -msse3 -msse4.1 -O3 #-g -DVERIFY
-COMMON_FLAGS = -fvisibility=hidden -Wall $(CFLAGS) $(MY_CFLAGS) $(MY_CXXFLAGS)
+COMMON_FLAGS = -fvisibility=hidden -Wall $(CFLAGS) $(MY_CFLAGS) $(MY_CXXFLAGS) $(CPPFLAGS)
 
 SO_CXXFLAGS = $(COMMON_FLAGS) -fPIC
-SO_LFLAGS = $(COMMON_FLAGS)
+SO_LFLAGS = $(COMMON_FLAGS) $(LDFLAGS)
 AR_CXXFLAGS = $(COMMON_FLAGS)
 
 # -DVERIFY implies -DDEBUG

=== debian/changelog ===
knot-resolver (2.3.0-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * note the DEP-14 debian/stretch-backports branch

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 22 May 2018 10:55:17 -0400

knot-resolver (2.3.0-3) unstable; urgency=medium

  * create knot-resolver user correctly in postinst (Closes: #894580)
  * d/changelog: update to acknowledge CVE-2018-1110

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 14 May 2018 11:58:29 -0400

knot-resolver (2.3.0-2) unstable; urgency=medium

  * only build against libsystemd on linux architectures

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 26 Apr 2018 11:56:29 -0400

knot-resolver (2.3.0-1) unstable; urgency=medium

  * new upstream release
    - resolves CVE-2018-1110
  * drop patches already upstream
  * ship prefill module
  * d/copyright: adjust years of main stanza
  * add trie_* and kr_zonecut_is_empty to symbols
  * Standards-Version: bump to 4.1.4 (no changes needed)
  * drop unnecessary build-dependencies

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 24 Apr 2018 19:20:45 -0400

knot-resolver (2.2.0-1) unstable; urgency=medium

  * new upstream release
    - move from libkres6 to libkres7 due to ABI change
  * drop patches already merged upstream
  * avoid shipping root.hints and icann-ca.pem without a patch
  * work around https://gitlab.labs.nic.cz/knot/knot-resolver/issues/338
  * renumbering patches for cleanliness
  * use externally-set CPPFLAGS during build
  * clean up build of lua-aho-corasick
  * document copyright better to drop a lintian override
  * clarify rationales behind lintian-overrides
  * be clearer about keyfile-ro restarting kresd in kresd.8

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 08 Apr 2018 23:46:47 -0400

=== debian/control ===
--- 
+++ 
@@ -17,21 +17,17 @@
  libedit-dev,
  libgeoip-dev,
  libgnutls28-dev,
- libhiredis-dev,
- libjansson-dev,
  libknot-dev (>= 2.6.4),
  liblmdb-dev,
  libluajit-5.1-dev,
- libmemcached-dev,
- libsystemd-dev (>= 227),
+ libsystemd-dev (>= 227) [linux-any],
  libuv1-dev,
  luajit,
  pkg-config,
- python3,
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://www.knot-resolver.cz/
 Vcs-Browser: https://salsa.debian.org/dns-team/knot-resolver
-Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git
+Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git -b debian/stretch-backports
 Rules-Requires-Root: no
 
 Package: knot-resolver
@@ -39,7 +35,7 @@
 Depends:
  adduser,
  dns-root-data,
- libkres6 (= ${binary:Version}),
+ libkres7 (= ${binary:Version}),
  lua-sec,
  lua-socket,
  ${misc:Depends},
@@ -103,7 +99,7 @@
  .
  This package contains Knot Resolver Documentation.
 
-Package: libkres6
+Package: libkres7
 Architecture: any
 Section: libs
 Depends:
@@ -127,7 +123,7 @@
 Architecture: any
 Section: libdevel
 Depends:
- libkres6 (= ${binary:Version}),
+ libkres7 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:

## knot-resolver 3.0.0

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+SHELL=/bin/bash -o pipefail -o errexit
+
 include config.mk
 include platform.mk
 
@@ -16,7 +18,7 @@
 .PHONY: all install check clean doc info lint
 
 # Dependencies
-KNOT_MINVER := 2.6.4
+KNOT_MINVER := 2.7.1
 $(eval $(call find_lib,libknot,$(KNOT_MINVER),yes))
 $(eval $(call find_lib,libdnssec,$(KNOT_MINVER),yes))
 $(eval $(call find_lib,libzscanner,$(KNOT_MINVER),yes))
@@ -30,8 +32,6 @@
 $(eval $(call find_bin,doxygen))
 $(eval $(call find_bin,sphinx-build))
 $(eval $(call find_pythonpkg,breathe))
-#$(eval $(call find_lib,libmemcached,1.0))
-#$(eval $(call find_lib,hiredis,,yes))
 $(eval $(call find_lib,socket_wrapper))
 $(eval $(call find_lib,libsystemd,227))
 $(eval $(call find_lib,gnutls))
@@ -84,7 +84,7 @@
 
 # Overview
 info:
-	$(info Target:     Knot DNS Resolver $(VERSION)-$(PLATFORM))
+	$(info Target:     Knot Resolver $(VERSION)-$(PLATFORM))
 	$(info Compiler:   $(CC) $(BUILD_CFLAGS))
 	$(info Linker:     $(CCLD) $(BUILD_LDFLAGS))
 	$(info )
@@ -116,11 +116,9 @@
 	$(info [$(HAS_sphinx-build)] sphinx-build (doc))
 	$(info [$(HAS_breathe)] python-breathe (doc))
 	$(info [$(HAS_go)] go (modules/go, Go buildmode=c-shared support))
-#	$(info [$(HAS_libmemcached)] libmemcached (modules/memcached))
-#	$(info [$(HAS_hiredis)] hiredis (modules/redis))
 	$(info [$(HAS_cmocka)] cmocka (tests/unit))
 	$(info [$(HAS_libsystemd)] systemd (daemon))
-	$(info [$(HAS_nettle)] nettle (modules/cookies))
+#	$(info [$(HAS_nettle)] nettle (modules/cookies))
 	$(info [$(HAS_ltn12)] Lua socket ltn12 (trust anchor bootstrapping))
 	$(info [$(HAS_ssl.https)] Lua ssl.https (trust anchor bootstrapping))
 	$(info [$(HAS_libedit)] libedit (client))
@@ -163,10 +161,13 @@
 endif
 
 # Check if it has nettle to support DNS cookies
-ifeq ($(HAS_nettle), yes)
-BUILD_CFLAGS += -DENABLE_COOKIES
-ENABLE_COOKIES := yes
-endif
+
+# temporarily turn off cookies
+#ifeq ($(HAS_nettle), yes)
+#BUILD_CFLAGS += -DENABLE_COOKIES
+#ENABLE_COOKIES := yes
+#endif
+ENABLE_COOKIES := no
 
 # Installation directories
 $(DESTDIR)$(MODULEDIR):

=== tests/deckard/Makefile ===
# Defaults
PYTHON ?= python3
LIBEXT := .so
PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
	LIBEXT := .dylib
endif

# Dependencies
include platform.mk
libcwrap_DIR := contrib/libswrap
libcwrap_cmake_DIR := $(libcwrap_DIR)/obj
libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper$(LIBEXT).0
ifeq ($(PLATFORM),Darwin)
	libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper.0$(LIBEXT)
endif
libfaketime_DIR := contrib/libfaketime
libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime$(LIBEXT).1

# Platform-specific targets
ifeq ($(PLATFORM),Darwin)
	libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime.1$(LIBEXT)
	preload_syms := DYLD_LIBRARY_PATH=$(DYLD_LIBRARY_PATH) DYLD_FORCE_FLAT_NAMESPACE=1 DYLD_INSERT_LIBRARIES="$(libfaketime):$(libcwrap)"
else
	preload_syms := LD_PRELOAD="$(libfaketime):$(libcwrap)"
endif


# Targets
all:
	@echo "Deckard is now run using *run.sh scripts in its root directory."
	@echo "To build the dependencies (libfaketime and libcwrap) run 'make depend'."
	exit 1
depend: $(libfaketime) $(libcwrap)
	@echo "export $(preload_syms)" > env.sh

# Synchronize submodules
submodules: .gitmodules
	@git submodule update --init
# indirection through submodules target is necessary
# to prevent make from running "git submodule" commands in parallel
$(libfaketime_DIR)/Makefile $(libcwrap_DIR)/CMakeLists.txt: submodules
$(libfaketime): $(libfaketime_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libfaketime_DIR)
$(libcwrap_cmake_DIR):$(libcwrap_DIR)/CMakeLists.txt
	@mkdir -p $(libcwrap_cmake_DIR)
$(libcwrap_cmake_DIR)/Makefile: $(libcwrap_cmake_DIR)
	@cd $(libcwrap_cmake_DIR); cmake ..
$(libcwrap): $(libcwrap_cmake_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libcwrap_cmake_DIR)


.PHONY: submodules depend all

check:
	@echo Running unittests using pytest
	${PYTHON} -m pytest

=== tests/deckard/requirements.txt ===
dnspython>=1.15
Jinja2>=2.8
PyYAML
python-augeas
pytest
pytest-xdist

=== debian/changelog ===
knot-resolver (3.0.0-9) unstable; urgency=medium

  * autopkg: allow stderr on "make installcheck"

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 12 Sep 2018 13:02:45 -0400

knot-resolver (3.0.0-8) unstable; urgency=medium

  * avoid stderr during autopkgtest
  * refresh patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 12 Sep 2018 09:51:40 -0400

knot-resolver (3.0.0-7) unstable; urgency=medium

  * try upstream proposed test suite change

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 11 Sep 2018 23:58:14 -0400

knot-resolver (3.0.0-6) unstable; urgency=medium

  * stop building knot-resolver on arm64 (Closes: #907729)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Sep 2018 19:30:10 -0400

knot-resolver (3.0.0-5) unstable; urgency=medium

  * roundtrip test: increase verbosity
  * roundtrip test: avoid long timeouts if UDP query fails
  * autopkgtest: improve call to "make installcheck"

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 31 Aug 2018 21:10:39 -0400

knot-resolver (3.0.0-4) unstable; urgency=medium

  * Re-enable tests on all architectures
  * autopkgtest: be more verbose about error
  * autopkgtest: allow specifying module directory
  * point to modules needed to run roundtrip test at build time

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 31 Aug 2018 14:00:24 -0400

knot-resolver (3.0.0-3) unstable; urgency=medium

  * improve autopkgtest
  * autopkgtest: env vars can select which kdig and kresd to test
  * run roundtrip test at compile time too

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 31 Aug 2018 11:36:17 -0400

knot-resolver (3.0.0-2) unstable; urgency=medium

  * autopkgtest: added full roundtrip tests

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Aug 2018 14:41:02 -0400

knot-resolver (3.0.0-1) unstable; urgency=medium

  * new upstream release
  * Standards-Version: bump to 4.2.1 (no changes needed)
  * build-depend on libknot 2.7 or later

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 27 Aug 2018 18:42:45 -0400

knot-resolver (2.4.1-1) unstable; urgency=medium

  * new upstream release
   - resolves CVE-2018-10920
  * k-r.postinst: strip trailing whitespace
  * clean up patches already adopted upstream
  * ship rebinding lua module
  * use upstream-preferred systemd service configuration
  * tell lintian not to complain about kresd.target
  * tighten up build-deps on libknot-dev
  * three symbols (re)introduced into libkres7
  * Standards-Version: bump to 4.2.0 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 27 Aug 2018 18:22:48 -0400

knot-resolver (2.3.0-4) unstable; urgency=medium

  * try to restart any running kresd daemon on upgrade
  * correct systemctl start documentation (Closes: #891838)
  * fix FTBFS on kfreebsd (Closes: #900013)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 24 May 2018 13:10:31 -0400

=== debian/control ===
--- 
+++ 
@@ -13,29 +13,33 @@
 Build-Depends:
  debhelper (>= 11~),
  dns-root-data,
+ gnutls-bin <!nocheck>,
+ knot-dnsutils <!nocheck>,
  libcmocka-dev (>= 1.0.0),
  libedit-dev,
  libgeoip-dev,
  libgnutls28-dev,
- libknot-dev (>= 2.6.4),
+ libknot-dev (>= 2.7),
  liblmdb-dev,
  libluajit-5.1-dev,
  libsystemd-dev (>= 227) [linux-any],
  libuv1-dev,
  luajit,
  pkg-config,
-Standards-Version: 4.1.4
+ socat <!nocheck>,
+Standards-Version: 4.2.1
 Homepage: https://www.knot-resolver.cz/
 Vcs-Browser: https://salsa.debian.org/dns-team/knot-resolver
-Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git -b debian/stretch-backports
+Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git
 Rules-Requires-Root: no
 
 Package: knot-resolver
+# actually "Architecture: any [!arm64]" via debian/rules, see #907729
 Architecture: any
 Depends:
  adduser,
  dns-root-data,
- libkres7 (= ${binary:Version}),
+ libkres8 (= ${binary:Version}),
  lua-sec,
  lua-socket,
  ${misc:Depends},
@@ -60,6 +64,7 @@
  nodes depending on the contention without downtime.
 
 Package: knot-resolver-module-http
+# actually "Architecture: any [!arm64]" via debian/rules, see #907729
 Architecture: all
 Depends:
  libjs-bootstrap,
@@ -99,7 +104,7 @@
  .
  This package contains Knot Resolver Documentation.
 
-Package: libkres7
+Package: libkres8
 Architecture: any
 Section: libs
 Depends:
@@ -123,7 +128,7 @@
 Architecture: any
 Section: libdevel
 Depends:
- libkres7 (= ${binary:Version}),
+ libkres8 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:

=== debian/rules ===
--- 
+++ 
@@ -18,14 +18,14 @@
 export MODULEDIR=/usr/lib/knot-resolver
 export ETCDIR=/etc/knot-resolver
 
-RUN_TESTS := yes
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),hurd-i386 mips mipsel ppc64 ppc64el armel armhf arm64 kfreebsd-amd64 kfreebsd-i386))
-  $(warning Disabling checks on $(DEB_HOST_ARCH))
-  RUN_TESTS := no
+# see https://bugs.debian.org/907729
+LUA_LUD_BROKEN_ARCHES := arm64
+ifneq (, $(filter $(DEB_HOST_ARCH), $(LUA_LUD_BROKEN_ARCHES)))
+  KRESD_EXCLUDE_ARCHES := -Nknot-resolver -Nknot-resolver-module-http
 endif
 
 %:
-	dh $@
+	dh $@ $(KRESD_EXCLUDE_ARCHES)
 
 override_dh_auto_clean-indep:
 	dh_auto_clean -- doc-clean http-clean
@@ -42,7 +42,8 @@
 	cd doc && sphinx-build -b html -D html_theme=nature . html
 
 override_dh_auto_install-arch:
-	dh_auto_install --destdir=debian/tmp -- V=1
+	dh_auto_install --destdir=debian/tmp -- V=1 KEYFILE_DEFAULT=/usr/share/dns/root.key
+	rm -f debian/tmp/etc/knot-resolver/root.hints debian/tmp/etc/knot-resolver/icann-ca.pem
 
 override_dh_auto_install-indep:
 # install just the http/2 module
@@ -56,8 +57,12 @@
 
 override_dh_auto_test-indep:
 override_dh_auto_test-arch:
-ifeq ($(RUN_TESTS),yes)
 	dh_auto_test -- V=1
+ifeq (, $(filter nocheck, $(DEB_BUILD_OPTIONS)))
+ifeq (, $(filter $(DEB_HOST_ARCH), $(LUA_LUD_BROKEN_ARCHES)))
+	mkdir -p test-modules && (cd test-modules && ln -sf ../modules/*/*.lua ../modules/*/*.so ../modules/policy/lua-aho-corasick/*.lua ../modules/policy/lua-aho-corasick/*.so ../daemon/lua/* ./)
+	MODULE_DIR=$(CURDIR)/test-modules LD_LIBRARY_PATH=$(CURDIR)/lib KRESD=$(CURDIR)/daemon/kresd debian/tests/roundtrip
+endif
 endif
 
 override_dh_missing:

=== debian/tests/control ===
Test-Command: make -k installcheck V=1 PREFIX=/usr ROOTHINTS=/usr/share/dns/root.hints KEYFILE_DEFAULT=/usr/share/dns/root.key
Depends: @, @builddeps@, lua-cqueues
Restrictions: allow-stderr

Tests: roundtrip
Depends: gnutls-bin, knot-dnsutils, knot-resolver, socat

## knot-resolver 3.2.0

=== debian/changelog ===
knot-resolver (3.2.0-1) unstable; urgency=medium

  * new upstream release
  * bump ABI from libkres8 to libkres9
  * drop reproducibility patch, adopted upstream
  * include experimental_dot_auth module (recommend: lua-basexx for it)
  * d/copyright: removed reference to ISAAC, removed upstream

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 19 Dec 2018 19:23:37 -0500

knot-resolver (3.1.0-1) unstable; urgency=medium

  * new upstream release
  * set knot-resolver-doc to Multi-Arch: foreign
  * drop upstreamed patch; avoid use of git during installcheck
  * make reproducible datestamp in kresd(8)
  * increase build-dep on libknot to 2.7.2
  * updated libkres8.symbols
  * minimize upstream signing keys
  * drop unused lintian-overrides

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 20 Nov 2018 15:47:19 -0500

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libedit-dev,
  libgeoip-dev,
  libgnutls28-dev,
- libknot-dev (>= 2.7),
+ libknot-dev (>= 2.7.2),
  liblmdb-dev,
  libluajit-5.1-dev,
  libsystemd-dev (>= 227) [linux-any],
@@ -39,13 +39,14 @@
 Depends:
  adduser,
  dns-root-data,
- libkres8 (= ${binary:Version}),
+ libkres9 (= ${binary:Version}),
  lua-sec,
  lua-socket,
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
  knot-resolver-module-http,
+ lua-basexx,
 Description: caching, DNSSEC-validating DNS resolver
  The Knot DNS Resolver is a caching full resolver implementation
  written in C and LuaJIT, including both a resolver library and a
@@ -89,6 +90,7 @@
 
 Package: knot-resolver-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  libjs-jquery,
@@ -104,7 +106,7 @@
  .
  This package contains Knot Resolver Documentation.
 
-Package: libkres8
+Package: libkres9
 Architecture: any
 Section: libs
 Depends:
@@ -128,7 +130,7 @@
 Architecture: any
 Section: libdevel
 Depends:
- libkres8 (= ${binary:Version}),
+ libkres9 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
